<template>
  <q-layout>
    <q-toolbar class="q-py-sm q-px-lg" v-if="!initialSearchComplete">
      <img src="/imgs/land-ho-logo.svg" height="60px" alt="Land Ho logo" />
      <q-space />
      <q-btn flat round dense to="/app/history" class="no-right-margin">
        <q-avatar size="32px">
          <img src="/imgs/history.svg" alt="History icon" />
        </q-avatar>
      </q-btn>
      <q-btn outline round dense color="transparent" class="q-mx-md" size="md">
        <q-avatar size="32px">
          <q-img
            :src="userAvatar"
            transition="pulse"
            spinner-color="accent"
          ></q-img>
        </q-avatar>
        <q-menu :offset="[18, 10]" auto-close class="shadow-24">
          <q-list>
            <q-item>
              <q-item-section class="text-black">
                {{ userName }}
              </q-item-section>
            </q-item>
            <q-item clickable @click="signOut">
              <q-item-section avatar>
                <img src="/imgs/sign-out.svg" alt="Sign out icon" />
              </q-item-section>
              <q-item-section>Sign out</q-item-section>
            </q-item>
          </q-list>
        </q-menu>
      </q-btn>
    </q-toolbar>

    <q-page>
      <div class="col1-2 bg-color" style="height: 100vh" v-if="showGreeting">
        <!-- style="background-image: url('/img/signed-in-wave.svg'); background-repeat: no-repeat; background-size: contain;" -->
        <!-- greeting -->

        <div class="signed-in-wave">
          <div class="col1-2 greeting">
            <q-img
              :src="'/imgs/land-ho-logo-icon-circle-no-bg.svg'"
              style="height: 56px; width: 56px; margin-bottom: 32px"
              v-if="initialSearchComplete"
            ></q-img>
            <div class="col1-2 greeting">
              Every search query belongs to you now, cap’n.
            </div>
            <q-toolbar class="landing-toolbar" v-if="!initialSearchComplete">
              <div class="column items-center">
                <q-btn
                  round
                  dense
                  color="white"
                  class="q-mx-md q-mx-md-2 col"
                  @click="menu = !menu"
                >
                  <q-img
                    :src="
                      searchEngines.find(
                        (se) => se.id === this.currentSearchEngine
                      ).avatar
                    "
                  ></q-img>
                  <q-menu :offset="[18, 10]" auto-close class="shadow-24">
                    <q-list style="min-width: 100px">
                      <q-item
                        clickable
                        v-for="se in searchEngines"
                        :key="se.id"
                        @click="setSearchEngine(se.id)"
                      >
                        <q-item-section avatar>
                          <q-img :src="se.avatar"></q-img>
                        </q-item-section>
                        <q-item-section>{{ se.name }}</q-item-section>
                      </q-item>
                    </q-list>
                  </q-menu>
                </q-btn>
                <img
                  src="/imgs/down-arrow.svg"
                  height="5px"
                  class="col menu-indicator"
                  :class="menu ? 'menu' : ''"
                />
              </div>
              <q-input
                :placeholder="searchPlaceholder"
                ref="search"
                style="background-color: rgba(255, 255, 255, 0.75)"
                height="48px"
                color
                grow
                rounded
                outlined
                clearable
                clear-icon="img:imgs/bx-x-circle.svg"
                type="search"
                standout
                v-model="searchTerm"
                class="lh-searchbar"
                @keyup.enter="doSearch"
              ></q-input>
              <q-space></q-space>
            </q-toolbar>
          </div>

          <div class="col1-2">
            <div class="greeting-explainer">
              Select the search engine logo to change your provider or the clock
              icon to view your full history.
            </div>
          </div>

          <div class="col-6 extra-wave">
            <div class="row">
              <div class="col-12 col-sm-8 offset-sm-2 history-bg">
                <div class="RECENT-HISTORY">RECENT HISTORY</div>
                <div class="recent-history-wrapper">
                  <q-list style="background-color: #fff">
                    <q-item
                      v-for="search in recentHistory"
                      :key="search.timestamp"
                      clickable
                      v-ripple
                      @click="historySearch(search)"
                    >
                      <q-item-section>
                        <q-item-label class="lh-search-meta self-start">
                          <img src="/imgs/search.svg" alt="Search icon" />
                          &nbsp;{{ lhDateFormat(search.timestamp) }}
                          &nbsp;
                          <span color="#b375ff">•</span>
                          &nbsp;
                          {{ search.src.name }}
                        </q-item-label>
                        <q-item-label class="This-is-the-thing-I self-start">
                          {{ formattedSearchTerm(search) }}
                        </q-item-label>
                      </q-item-section>
                      <q-item-section
                        side
                        @click="removeSearch(search)"
                        class="trashmargin"
                      >
                        <img src="/imgs/trash-it.svg" alt="Delete icon" />
                      </q-item-section>
                    </q-item>
                  </q-list>
                </div>
                <q-btn
                  flat
                  no-wrap
                  unelevated
                  class="SEE-ALL-HISTORY"
                  label="SEE ALL HISTORY"
                  to="/app/history"
                />
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="column" v-else>
        <!-- search frame -->
        <div class="col-12">
          <div class="ship-bubble">
            <div class="ship-bubble-left">
              <div class="ship-bubble-text">
                Are ya havin’ issues loadin’ a search result?
                <br />Try openin’ the link in a new tab!
              </div>
            </div>
            <img
              src="/imgs/ship-bubble-2.svg"
              alt="Pirate ship bubble image"
              class="ship-bubble-img"
            />
          </div>
          <iframe
            ref="search-frame"
            name="search-frame"
            :src="search.src.url + search.searchTerm"
            referrerpolicy="no-referrer"
            seamless
            @click="searchclick"
            @change="searchclick"
            style="border: none"
          ></iframe>
        </div>
      </div>
    </q-page>
  </q-layout>
</template>
<script>
// import { userSession } from "boot/blockstack";
import { mapActions, mapGetters, mapState } from "vuex";
// eslint-disable-next-line no-undef
const isEmpty = require("lodash.isempty");
import { date } from "quasar";

export default {
  name: "Search",
  data() {
    return {
      iframeLoading: true,
      documentLoading: true,
      currentSearchEngine: 0,
      menu: false,
    };
  },
  // beforeUpdate() {
  //   if (this.search.searchTerm) {
  //     this.searchTerm = this.search.searchTerm;
  //   }
  // },
  computed: {
    ...mapState("user", ["user"]),
    ...mapGetters({
      search: "search/search",
      history: "search/userSearchHistory",
      searchEngines: "search/searchEngines",
      initialSearchComplete: "search/initialSearchComplete",
      currentSearchTerm: "search/currentSearchTerm",
    }),
    userAvatar() {
      let avatar = "";
      try {
        avatar = this.user.profile.image[0].contentUrl;
      } catch (error) {
        avatar = "/imgs/avatarrghh.svg";
      }
      return avatar;
    },
    userName() {
      if (this.user.profile.hasOwnProperty("name")) {
        return this.user.profile.name;
      } else if (this.user.hasOwnProperty("username")) {
        return this.user.username.substring(
          0,
          this.user.username.indexOf(".id")
        );
      } else {
        return this.user.identityAddress;
      }
    },
    searchTerm: {
      set(searchString) {
        this.setSearchTerm(searchString);
      },
      get() {
        return this.currentSearchTerm;
      },
    },
    showGreeting() {
      return isEmpty(this.search);
    },
    recentHistory() {
      if (this.history.length < 5) {
        return this.history;
      } else {
        return this.history.slice(0, 5);
      }
    },
    searchPlaceholder() {
      return `Search ${
        this.searchEngines.find((se) => se.id === this.currentSearchEngine).name
      }`;
    },
  },
  watch: {
    searchTerm() {
      if (!this.searchTerm) {
        this.resetSearch();
      }
    },
  },

  methods: {
    ...mapActions({
      removeSearch: "search/removeSearch",
      addSearch: "search/addSearch",
      clearSearch: "search/clearSearch",
      setSearchTerm: "search/setSearchTerm",
    }),
    formattedSearchTerm(search) {
      let st = search.searchTerm;
      if (st.length >= 80) {
        return st.substring(0, 77).concat("...");
      } else {
        return st;
      }
    },
    searchclick(e) {
      if (process.env.DEV) console.log("click event: ", e);
    },
    onLoad() {
      if (process.env.DEV) console.log("iframe loaded");
      this.iframeLoading = false;
    },
    onIframeLoad() {
      if (process.env.DEV) console.log("iframe loaded");
    },
    onDocumentLoad() {
      if (process.env.DEV) console.log("document loaded");
      this.documentLoading = false;
    },
    lhDateFormat(ts) {
      return date.formatDate(ts, "MM/DD/YYYY HH:MM:SS a");
    },
    setSearchEngine(param) {
      this.currentSearchEngine = param;
      if (this.searchTerm) {
        this.doSearch();
      }
    },
    signOut() {
      this.$userSession.signUserOut();
      this.$router.push("/");
    },
    historySearch(search) {
      this.addSearch({
        timestamp: Date.now(),
        src: search.src,
        searchTerm: search.searchTerm,
      });
    },
    doSearch() {
      let searchEngine = this.searchEngines.find(
        (se) => se.id === this.currentSearchEngine
      );
      let searchString = this.searchTerm;
      this.addSearch({
        timestamp: Date.now(),
        src: searchEngine,
        searchTerm: searchString,
      });
    },
    resetSearch() {
      this.clearSearch();
      this.$nextTick(function () {
        if (this.$router.page !== "app") {
          this.$router.push("/app/search");
        }
      });
    },
  },
};
</script>

<style>
iframe {
  height: 95vh;
  width: 100%;
}
.menu-indicator {
  margin-top: 3px;
  margin-right: 16px;
}

.landing-toolbar {
  height: 160px;
  margin-bottom: -32px;
}

.extra-wave {
  background: url(/imgs/foreground-wave.svg);
  background-repeat: no-repeat;
  background-size: cover;
  min-height: 283px;
}

.test {
  height: 48px !important;
}

.q-mx-md-2 {
  margin-left: 0px !important;
}

.greeting {
  max-width: 880px;
  font-family: "IBM Plex Sans";
  font-size: 36px;
  font-weight: bold;
  font-style: normal;
  font-stretch: normal;
  line-height: normal;
  letter-spacing: normal;
  text-align: center;
  color: #27261e;
  margin: 0 auto;
  margin-top: 40px;
  margin-bottom: 0px;
  padding-left: 8px;
  padding-right: 8px;
}
.greeting-divider {
  width: 80px;
  height: 16px;
  border-radius: 4px;
  background-color: #d5b3ff;
  margin: 0 auto;
}
.greeting-explainer {
  max-width: 720px;
  font-family: "IBM PLex Sans";
  font-size: 14px;
  font-weight: 400;
  font-style: normal;
  font-stretch: normal;
  line-height: normal;
  letter-spacing: normal;
  text-align: center;
  color: #7f36da;
  margin: 0 auto;
  margin-top: 32px;
  margin-bottom: 96px;
  padding-left: 8px;
  padding-right: 8px;
}
.history-bg {
  max-width: 936px;
  border-radius: 8px;
  box-shadow: 0 16px 24px 0 rgba(120, 93, 153, 0.2);
  background-color: #ffffff;
  overflow-y: hidden;
  margin-top: 32px;
  margin-bottom: 24px;
  padding: 24px;
}
.RECENT-HISTORY {
  height: 26px;
  font-family: "IBM Plex Sans";
  font-size: 24px;
  font-weight: bold;
  font-style: normal;
  font-stretch: normal;
  line-height: 1.08;
  letter-spacing: normal;
  color: #b375ff;
  padding-left: 0px;
  padding-right: 0px;
  margin-bottom: 24px;
}
.recent-history-wrapper {
  overflow-y: hidden;
}
.SEE-ALL-HISTORY {
  max-width: 118px;
  height: 26px;
  font-family: "IBM Plex Sans";
  font-size: 14px;
  font-weight: bold;
  font-style: normal;
  font-stretch: normal;
  line-height: 1.86;
  letter-spacing: normal;
  color: #b375ff;
  padding-left: 0px;
  margin-top: 24px;
}

.col1-2 {
  height: auto;
}

.signed-in-wave {
  margin-top: 32px;
  padding-top: 32px;
  background-image: url(/imgs/signed-in-wave.svg);
  background-repeat: no-repeat;
  background-size: cover;
  background-color: #fefefe;
}

.col-6 {
  margin-top: -24px;
  padding-left: 8px;
  padding-right: 8px;
}

.bg-color {
  background-color: #b375ff;
}
.lh-search-meta {
  height: 14px;
  font-size: 11px;
  font-weight: normal;
  font-style: normal;
  font-stretch: normal;
  line-height: normal;
  letter-spacing: normal;
  color: #7a767f;
  margin-left: -10px;
}
.This-is-the-thing-I {
  height: 18px;
  font-size: 14px;
  font-weight: normal;
  font-style: normal;
  font-stretch: normal;
  line-height: normal;
  letter-spacing: normal;
  color: #27261e;
  margin-left: 0px;
  margin-left: -10px;
}

.trashmargin {
  margin-right: -10px;
}

.ship-bubble-img {
  width: 84px;
  height: 48px;
  margin-top: 0px;
  -webkit-align-self: center;
  -ms-flex-item-align: center;
  -ms-grid-row-align: center;
  align-self: center;
}

.ship-bubble {
  position: fixed;
  left: auto;
  top: auto;
  right: 0%;
  bottom: 0%;
  display: -webkit-box;
  display: -webkit-flex;
  display: -ms-flexbox;
  display: flex;
  margin-right: 8px;
  margin-bottom: 8px;
  -webkit-box-orient: horizontal;
  -webkit-box-direction: normal;
  -webkit-flex-direction: row;
  -ms-flex-direction: row;
  flex-direction: row;
  -webkit-box-pack: end;
  -webkit-justify-content: flex-end;
  -ms-flex-pack: end;
  justify-content: flex-end;
  -webkit-box-align: center;
  -webkit-align-items: center;
  -ms-flex-align: center;
  align-items: center;
}

.ship-bubble-left {
  height: 48px;
  min-width: 48px;
  -webkit-align-self: center;
  -ms-flex-item-align: center;
  -ms-grid-row-align: center;
  align-self: center;
  border-top-left-radius: 100px;
  border-bottom-left-radius: 100px;
  background-color: #ecddff;
}

.ship-bubble-text {
  display: -webkit-box;
  display: -webkit-flex;
  display: -ms-flexbox;
  display: flex;
  height: 48px;
  padding-left: 24px;
  -webkit-box-orient: horizontal;
  -webkit-box-direction: normal;
  -webkit-flex-direction: row;
  -ms-flex-direction: row;
  flex-direction: row;
  -webkit-box-pack: center;
  -webkit-justify-content: center;
  -ms-flex-pack: center;
  justify-content: center;
  -webkit-box-align: center;
  -webkit-align-items: center;
  -ms-flex-align: center;
  align-items: center;
  font-family: "IBM Plex Sans", sans-serif;
  color: #27261e;
  font-size: 12px;
  line-height: 16px;
  font-weight: 400;
}

@media only screen and (max-width: 425px) {
  .logo {
    height: 64px !important;
  }

  .menu-indicator {
    margin-right: 8px;
  }

  .landing-toolbar {
    height: 120px;
    margin-bottom: -32px;
  }
  .ship-bubble-text {
    font-size: 10px;
    line-height: 15px;
  }
  .greeting {
    font-size: 24px;
    line-height: 28px;
    margin-left: 16px;
    margin-right: 16px;
    margin-top: 0px;
  }
  .greeting-divider {
    width: 80px;
    height: 16px;
    border-radius: 4px;
    background-color: #d5b3ff;
    margin: 0 auto;
  }

  .greeting-explainer {
    font-size: 12px;
    line-height: 18px;
    margin-bottom: 104px;
    margin-left: 16px;
    margin-right: 16px;
  }

  .RECENT-HISTORY {
    font-size: 18px;
    margin-bottom: 8px;
  }
  .vertical-middle {
    margin-top: 40px !important;
  }
}
.lh-searchbar {
  font-size: 14px;
  width: 100%;
  margin-left: 0px;
  border-radius: 100px;
  box-shadow: 0 8px 16px -8px rgba(120, 93, 153, 0.2);
}

/* @media only screen and (max-width: 425px) {
  .menu-indicator {
    margin-right: 4px;
  }

  .no-right-margin {
    margin-right: 0px;
  }
} */
img {
  transition: transform 0.2s;
}
img.menu {
  transform: rotate(-180deg);
}
</style>
